;***************************************;***** basic audio synthesizer *************************************************; The seven buttons act as a keyboard using PortD. Any bit of ; PortB can be used as output to an earphone.; The program uses interrupt-driven tone generation.include "1200def.inc".device AT90S1200.def	Temp	=r16	;temporary register.def	reload	=r17	;holds timer reload value.def	output	=r18	;Hold ff or 00 for waveform.def	key	=r19	;which button is pressed.def	freq	=r20	;current frequency.def	savSREG	=r21	;save processor status word.def	keydown	=r22	;key pressed flag; Middle C is 262 Hz. Will need to interrrupt at each;half-cycle to toggle an output pin, interrupt every;0.00191 seconds or every 7640 machine cycles (at 4Mhz);So we need to prescale by 64 since 7640<255*64;the actual preload count will be 7640/64 = 119.equ	PreScal	=3	;timer prescale by 64.equ	C	=119	;time for 1/2 cycle middle C.equ	D	=106	;time for 1/2 cycle D.equ	E	=94	;time for 1/2 cycle E.equ	F	=89	;time for 1/2 cycle F.equ	G	=79	;time for 1/2 cycle G.equ	A	=71	;time for 1/2 cycle A.equ	B	=63	;time for 1/2 cycle B;***** Initialization.cseg.org $0000	rjmp RESET	;reset entry vector	reti		;external intrupt not used	rjmp TIMER	;timer 0 interrupt vector	reti		;Analog comparator not usedRESET:	ser	Temp		;set to all ones so that	out	DDRB,Temp	;PORTB = all outputs	ser	output		;init out to 1		ldi	Temp,exp2(TOIE0);enable timer intr	out	TIMSK, Temp	;TOIE0 is a bit number	ldi 	Temp, PreScal	;prescale timer	out 	TCCR0, Temp	clr	keydown		;start with no key pressed;If no button is pressed, interrupts are turned off, killing the tone.;If a button is already pressed, do nothing.;scan for any button pressed only of no key is downSPIN:	in	Temp, PIND	;check for no keys down	cpi	Temp, 0x7f	;top bit is not driven	breq	nokey	tst	keydown		;see if a key was already pressed	brne	SPIN		;if so, just wait		;if a key is newly pressed, process it	sbis    PIND,0x00	; if (SW0 == 0)     	ldi	freq, B		;    	sbis    PIND,0x01	; if (SW1 == 0)     	ldi	freq, A		;     	sbis    PIND,0x02	; if (SW2 == 0)    	ldi	freq, G				    	sbis    PIND,0x03	; if (SW3 == 0)    	ldi	freq, F		;     	sbis    PIND,0x04	; if (SW4 == 0)    	ldi	freq, E		;     	sbis    PIND,0x05	; if (SW5 == 0)    	ldi	freq, D		; D above middle C     	sbis    PIND,0x06	; if (SW6 == 0)    	ldi	freq, C		; middle C	ser	reload		;init tone time by setting	sub	reload, freq	;0xff-freq is time to overflow		ser	keydown		;set the keydown flag	sei			;enable all interrupts	rjmp	SPIN		;wait for something to happennokey:	cli			;turn off tone		clr	keydown		; mark no key down	rjmp	SPIN		;wait for something to happen;**** once per interrupt;which will be every 1/2 cycle of the audio signalTIMER:	in	savSREG, SREG	;save processor status	out 	TCNT0, reload	;make 1/2 cycle intr rate	com	output	out	PORTB, output	;flip the output bit	out	SREG, savSREG	;restore proc status	reti			;back to pgm